'''Ejercicio 1. [5 puntos] 

NOMBRE: 
APELLIDOS: 
HORA DE ENTREGA AL PROFESOR: 


Completad la implementación de la función es_correct(d, m, a) que
determina si la fecha que representan los tres enteros d, m y a es
correcta, suponiendo que d corresponde al día, m al mes, a al año y
que 1800 <= a <= 9999.

Tened en cuenta que los meses de Abril, Junio, Septiembre y Noviembre
tienen 30 días; el mes de Febrero tiene 29 días si el año es bisiesto
y 28 días si no lo es; y el resto de los meses tienen 31 días. Además, 
para que la fecha (d, m, a) sea correcta, d y m deben cumplir las dos 
condiciones siguientes:

I) 1 <= d <= 31 
II) 1 <= m <= 12


Por ejemplo, 

El 31 del 4 de 2015 es una fecha incorrecta, porque Abril tiene 30 días.

El 29 del 2 de 2016 es una fecha correcta, porque 2016 es un año bisiesto. 


Diseñad un doctest para la función es_correct que permita validar la
corrección de vuestra implementación.  El doctest que diseñéis no
puede coincidir con ninguno de los ejemplos de este enunciado. Además,
debe incluir un ejemplo en el que el resultado de la función
es_correct(d, m, a) sea True y otro en el que el resultado sea False.

Observad que se incluye la definición de la variable 'bisiesto' dentro 
de la definición de la función es_correct. Esta variable será cierta cuando 
a sea un año bisiesto y falsa en otro caso. 
'''


def es_correct(d, m, a):
    '''
    ESCRIBID VUESTRO DOCTEST A CONTINUACIÓN 
    >>> es_correct(31, 4, 2015)
    False
    >>> es_correct(29, 2, 2016)
    True
    >>> es_correct(29, 2, 2017)
    False
    >>> es_correct(30, 2, 2016)
    False
    >>> es_correct(50, 2, 2016)
    False
    >>> es_correct(30, 20, 2016)
    False
    '''    
    bisiesto = (a%4 == 0 and a%100 != 0) or a%400 ==0
    
    # ESCRIBID EL RESTO DE LA IMPLEMENTACIÓN DE ES_CORRECT A CONTINUACIÓN 
    if not (1 <= d <= 31 and 1 <= m <= 12): return False
    if (m == 2):
        if bisiesto: return d < 30
        else: return d < 29
    if (m == 4 or m == 6 or m == 9 or m == 11): return d < 31
    return True



if __name__ == '__main__':
    import doctest
    doctest.testmod(verbose = True)
